﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes
    #StartAtBoot: False
#End Region

Sub Process_Globals
End Sub

Sub Service_Create

	
End Sub

Sub Service_Start (StartingIntent As Intent)

	InitialActions
    ' Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)

End Sub

Sub Service_Destroy
	
End Sub

Sub InitialActions

	Dim intHeight                                           As Int
	Dim intLeft                                             As Int
	Dim intScreenHeight                                     As Int
	Dim intScreenWidth                                      As Int
	Dim intTop                                              As Int
	Dim intWidth                                            As Int

	Dim Button1                                             As Button
	Dim javaobjectInstance                                  As JavaObject
	Dim ImageView1                                          As ImageView
	Dim PanelOverlapped                                     As Panel
	Dim packagemanagerInstance                              As PackageManager
	
	PanelOverlapped.Initialize ("")
	PanelOverlapped.Color = Colors.Red
	javaobjectInstance.InitializeContext
	javaobjectInstance.RunMethod ("initialactions", Array (PanelOverlapped))
	
	' For panelOverLapped such fuctions as Left, Top, 100%, 100%y do not work.
	intScreenHeight = GetScreenHeight
	intScreenWidth = GetScreenWidth

	intWidth = Max (180dip, intScreenWidth * 0.5)
	intHeight = 60dip
	intLeft = (intScreenWidth - intWidth) / 2
	intTop = (intScreenHeight - intHeight) / 2
	SetPanelOverlappedPositionAndSize (intLeft, intTop, intWidth, intHeight)
	
	Button1.Initialize ("Button1")
	Button1.Text = "Button"
	Button1.TextColor = Colors.ARGB (255, 255, 255, 255)
	Button1.Color = Colors.ARGB (255, 0, 128, 0)
	PanelOverlapped.AddView (Button1, 10dip, 9dip, 100dip, 42dip)

	ImageView1.Initialize ("")
	
	ImageView1.Background = packagemanagerInstance.GetApplicationIcon (Application.PackageName)
	PanelOverlapped.AddView (ImageView1, 139dip, 12dip, 36dip, 36dip)
	
End Sub

Sub FinalActions

	Dim javaobjectInstance                                  As JavaObject

	javaobjectInstance.InitializeContext
	javaobjectInstance.RunMethod ("finalactions", Null)
	
End Sub

Sub Button1_Click
	
	Log ("Click")
	
End Sub

Sub GetScreenWidth As Int

	Dim javaobjectInstance                                  As JavaObject

	javaobjectInstance.InitializeContext
	Return javaobjectInstance.RunMethod ("getscreenwidth", Null)
	
End Sub

Sub GetScreenHeight As Int

	Dim javaobjectInstance                                  As JavaObject

	javaobjectInstance.InitializeContext
	Return javaobjectInstance.RunMethod ("getscreenheight", Null)
	
End Sub

Sub SetPanelOverlappedPositionAndSize (Left As Int, Top As Int, Width As Int, Height As Int)

	Dim javaobjectInstance                                  As JavaObject

	javaobjectInstance.InitializeContext
	javaobjectInstance.RunMethod ("setpaneloverlappedpositionandsize", Array (Left, Top, Width, Height))
	
End Sub

#If Java

import android.content.Context;
import android.graphics.PixelFormat;
import android.os.Build;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.WindowManager.LayoutParams;
import android.widget.Button;

import android.content.res.Configuration;

private ViewGroup panel;
private View      topLeftView;

public void setpaneloverlappedpositionandsize (int Left, int Top, int Width, int Height)
	{
	WindowManager windowmanager = (WindowManager) getSystemService (Context.WINDOW_SERVICE);
	WindowManager.LayoutParams params = (LayoutParams) panel.getLayoutParams ();
	params.x = Left;
	params.y = Top;
	params.width = Width;
	params.height = Height;
	windowmanager.updateViewLayout (panel, params);				
	}
	
public int getscreenwidth ()
	{
	return getResources().getDisplayMetrics().widthPixels;
	}

public int getscreenheight ()
	{
	return getResources().getDisplayMetrics().heightPixels;
	}
	
public void finalactions ()
    {
    if (panel != null)
        {
		WindowManager windowmanager = (WindowManager) getSystemService (Context.WINDOW_SERVICE);
        panel.removeAllViews ();
		windowmanager.removeView (panel);
		panel = null;
        windowmanager.removeView (topLeftView);        
        topLeftView = null;
        }
    }

public void initialactions (ViewGroup b4a_panel)
    {
    WindowManager windowmanager = (WindowManager) getSystemService (Context.WINDOW_SERVICE);
    panel = b4a_panel;
	setTouchListener ();

	int LAYOUT_FLAG;
	if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O)
		{
		LAYOUT_FLAG = WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY;
		} else {
		LAYOUT_FLAG = WindowManager.LayoutParams.TYPE_PHONE;
		}

    WindowManager.LayoutParams params = new WindowManager.LayoutParams
        (WindowManager.LayoutParams.WRAP_CONTENT,
        WindowManager.LayoutParams.WRAP_CONTENT,
        LAYOUT_FLAG,
        WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE | WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL,
        PixelFormat.TRANSLUCENT);
	params.gravity = Gravity.LEFT | Gravity.TOP;
	params.x = 0;
	params.y = 0;
	windowmanager.addView (panel, params);

	topLeftView = new View (this);
	WindowManager.LayoutParams topLeftParams = new WindowManager.LayoutParams
		(WindowManager.LayoutParams.WRAP_CONTENT,
		WindowManager.LayoutParams.WRAP_CONTENT,
		LAYOUT_FLAG,
		WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE | WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL,
		PixelFormat.TRANSLUCENT);
	topLeftParams.gravity = Gravity.LEFT | Gravity.TOP;
	topLeftParams.x = 0;
	topLeftParams.y = 0;
	topLeftParams.width = 0;
	topLeftParams.height = 0;
	windowmanager.addView (topLeftView, topLeftParams);
	}

private void setTouchListener ()
	{
    panel.setOnTouchListener (new OnTouchListener ()
        {
		private boolean       moving;
		private float         offsetX;
		private float         offsetY;
		private int           originalXPos;
		private int           originalYPos;
        private WindowManager windowmanager;
    	
		public boolean onTouch (View v, MotionEvent event)
			{
            if (windowmanager == null)
			   {
			   windowmanager = (WindowManager) getSystemService (Context.WINDOW_SERVICE);			  
			   }
			if (event.getAction() == MotionEvent.ACTION_DOWN)
				{
	    		float x = event.getRawX ();
	    		float y = event.getRawY ();
			    moving = false;
			    int [] location = new int [2];
	    		panel.getLocationOnScreen (location);

	    		originalXPos = location [0];
	    		originalYPos = location [1];

	    		offsetX = originalXPos - x;
	    		offsetY = originalYPos - y;

				}
			else if (event.getAction () == MotionEvent.ACTION_MOVE)
				{
	    		int [] topLeftLocationOnScreen = new int [2];
	    		topLeftView.getLocationOnScreen (topLeftLocationOnScreen);

	    		float x = event.getRawX ();
	    		float y = event.getRawY ();

	    		WindowManager.LayoutParams params = (LayoutParams) panel.getLayoutParams ();

	    		int newX = (int) (offsetX + x);
	    		int newY = (int) (offsetY + y);

	    		if (Math.abs (newX - originalXPos) < 1 && Math.abs (newY - originalYPos) < 1 && !moving)
					{
					return false;
	    			}

	    		params.x = newX - (topLeftLocationOnScreen [0]);
	    		params.y = newY - (topLeftLocationOnScreen [1]);

	    		windowmanager.updateViewLayout (panel, params);
	    		moving = true;
				}
			else if (event.getAction () == MotionEvent.ACTION_UP)
				{
	    		if (moving)
					{
					return true;
	    			}
				}
			return false;
    		}		
		} );
	}

@Override
public void onConfigurationChanged (Configuration newConfig) 
    {
    super.onConfigurationChanged (newConfig);
	// restart
	try	
		{
		_finalactions ();
    	_initialactions ();
		} 
	catch (Exception e)
		{
		}	
    }
#End If
